# Mentorenwahl: A fullstack application for assigning mentors to students based on their whishes.
# Copyright (C) 2022  Dominic Grimm
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

require "quartz_mailer"
require "kilt"

require "./mailers/*"

module Backend
  # Mailer definitions
  module Mailers
    Quartz.config do |config|
      config.smtp_enabled = true
      config.smtp_address = Backend.config.smtp.host
      config.smtp_port = Backend.config.smtp.port
      config.helo_domain = Backend.config.smtp.helo
      config.use_tls = EMail::Client::TLSMode::STARTTLS
      config.username = Backend.config.smtp.username
      config.password = Backend.config.smtp.password
      config.use_authentication = true
    end
  end
end
