# Configuration

## Environment variables

To change the environment variables edit the `.env` file.

| Name                                  | Type     | Description                                                                          |
| ------------------------------------- | -------- | ------------------------------------------------------------------------------------ |
| `URL`                                 | `String` | The webroot of the application to base of links and routing                          |
| `POSTGRES_USER`                       | `String` | Database user name                                                                   |
| `POSTGRES_PASSWORD`                   | `String` | Database password                                                                    |
| `BACKEND_URL`                         | `String` | Backend webroot (= `URL`)                                                            |
| `BACKEND_API_GRAPHQL_PLAYGROUND`      | `Bool`   | Enables GraphQL playground (automatically enabled when compiled in development mode) |
| `BACKEND_API_JWT_SECRET`              | `String` | Password to encrypt all authentication tokens with                                   |
| `BACKEND_API_JWT_EXPIRATION`          | `Int`    | Expiration time of authentication tokens in minutes                                  |
| `BACKEND_SMTP_HELO`                   | `String` | SMTP server HELO                                                                     |
| `BACKEND_SMTP_HOST`                   | `String` | SMTP server hostname                                                                 |
| `BACKEND_SMTP_PORT`                   | `Int`    | SMTP server port                                                                     |
| `BACKEND_SMTP_NAME`                   | `String` | Name to send emails with                                                             |
| `BACKEND_SMTP_USERNAME`               | `String` | SMTP account username                                                                |
| `BACKEND_SMTP_PASSWORD`               | `String` | SMTP account password                                                                |
| `BACKEND_LDAP_HOST`                   | `String` | LDAP server hostname                                                                 |
| `BACKEND_LDAP_PORT`                   | `Int`    | LDAP server port                                                                     |
| `BACKEND_LDAP_BASE_DN`                | `String` | LDAP virtual DN                                                                      |
| `BACKEND_LDAP_BASE_USER_DN`           | `String` | LDAP user group DN                                                                   |
| `BACKEND_LDAP_BIND_DN`                | `String` | LDAP admin account DN                                                                |
| `BACKEND_LDAP_BIND_PASSWORD`          | `String` | LDAP admin account password                                                          |
| `BACKEND_LDAP_CACHE_REFRESH_INTERVAL` | `Int`    | Periodical cache refresh interval in minutes                                         |

## Compile time

### Backend

Setting the `development` flag with `-Ddevelopment` flag on compiling the backend will result in being able to debug the API endpoints at `/graphql?development=true`. Also automatically enables the GraphQL playground at `/graphql`.
